create or replace procedure bsd_sendemail (p_receiver varchar2,p_sub varchar2,p_txt varchar2)
  is
  p_user varchar2(30) := '';
  p_pass varchar2(30) := '';
  p_sendor varchar2(20) := 'Gnie';
  p_server varchar2(20) := 'Mail_Server_IP';
  p_port number := 25;
  p_need_smtp number := 0;
  p_subject varchar2(4000);
  l_crlf varchar2(2) := utl_tcp.crlf;
  l_sendoraddress varchar2(4000);
  l_splite        varchar2(10) := '++';
  boundary            constant varchar2(256) := '-----BYSUK';
  first_boundary      constant varchar2(256) := '--' || boundary || l_crlf;
  last_boundary       constant varchar2(256) := '--' || boundary || '--' || l_crlf;
  multipart_mime_type constant varchar2(256) := 'multipart/mixed; boundary="' || boundary || '"';

  type address_list is table of varchar2(100) index by binary_integer;
  my_address_list address_list;
  ---------------------------------------ָʼַ----------------------------------------------
  procedure p_splite_str(p_str varchar2,p_splite_flag int default 1) is
    l_addr varchar2(254) := '';
    l_len  int;
    l_str  varchar2(4000);
    j      int := 0; --ʾʼַ߸ĸ
  begin
    /*ʼַбȥո񡢽;תΪ,*/
    l_str := trim(rtrim(replace(replace(p_str, ';', ','), ' ', ''), ','));
    l_len := length(l_str);
    for i in 1 .. l_len loop
      if substr(l_str, i, 1) <> ',' then
        l_addr := l_addr || substr(l_str, i, 1);
      else
        j := j + 1;
        if p_splite_flag = 1 then --ʾʼַ
          --ǰҪ'<>'ܶ佫ܷʼ
          l_addr := '<' || l_addr || '>';
          --ʼ͹
          my_address_list(j) := l_addr;
        end if;
        l_addr := '';
      end if;
      if i = l_len then
        j := j + 1;
        if p_splite_flag = 1 then
          --ʼ͹
          l_addr := '<' || l_addr || '>';
          my_address_list(j) := l_addr;
        end if;
      end if;
    end loop;
  end;
  ------------------------------------------------дʼͷʼ------------------------------------------
  procedure write_data(p_conn   in out nocopy utl_smtp.connection,
                       p_name   in varchar2,
                       p_value  in varchar2,
                       p_splite varchar2 default ':',
                       p_crlf   varchar2 default l_crlf) is
  begin
    /* utl_raw.cast_to_raw ԽҪ*/
    utl_smtp.write_raw_data(p_conn, utl_raw.cast_to_raw(convert(p_name||p_splite||p_value ||p_crlf, 'ZHS16CGB231280')));
  end;
  ----------------------------------------дmimeʼβ-----------------------------------------------------
  procedure end_boundary(conn in out nocopy utl_smtp.connection, last in boolean default false) is
  begin
    utl_smtp.write_data(conn, utl_tcp.crlf);
    if (last) then
      utl_smtp.write_data(conn, last_boundary);
    end if;
  end;
  ---------------------------------------------ʼĹ--------------------------------------------
  procedure p_email(p_sendoraddress2 varchar2, --͵ַ
                    p_receiveraddress2 varchar2) --ַܵ
   is
    l_conn utl_smtp.connection; --
  begin
    /*ʼʼϢʼ*/
    l_conn := utl_smtp.open_connection(p_server, p_port);
    utl_smtp.helo(l_conn, p_server);
    /* smtp¼У */
    if p_need_smtp = 1 then
      utl_smtp.command(l_conn, 'AUTH LOGIN', '');
      utl_smtp.command(l_conn, utl_raw.cast_to_varchar2(utl_encode.base64_encode(utl_raw.cast_to_raw(p_user))));
      utl_smtp.command(l_conn, utl_raw.cast_to_varchar2(utl_encode.base64_encode(utl_raw.cast_to_raw(p_pass))));
    end if;

    /*÷͵ַͽյַ*/
    utl_smtp.mail(l_conn, p_sendoraddress2);
    utl_smtp.rcpt(l_conn, p_receiveraddress2);

    /*ʼͷ*/
    utl_smtp.open_data(l_conn);
    /**/
    --write_data(l_conn, 'Date', to_char(sysdate-1/3, 'dd Mon yy hh24:mi:ss'));
    /*÷*/
    write_data(l_conn, 'From', p_sendor);
    /*ý*/
    write_data(l_conn, 'To', p_receiver);
    /*ʼ*/
    select replace('=?GB2312?B?'||utl_raw.cast_to_varchar2(utl_encode.base64_encode(rawtohex(p_sub)))||'?=',utl_tcp.crlf,'')     into p_subject from dual;
    write_data(l_conn, 'Subject', p_subject);

    write_data(l_conn, 'Content-Type', multipart_mime_type);
    utl_smtp.write_data(l_conn, utl_tcp.crlf);
    utl_smtp.write_data(l_conn, first_boundary);
    write_data(l_conn, 'Content-Type', 'text/html;charset=gb2312');
    --һУݲʾ
    utl_smtp.write_data(l_conn, utl_tcp.crlf);
    /* ʼ
      ѷָԭchr(10)ҪΪshellеøụ̀ж,ȰѶеݺϲһУ l_spliteָ
      Ȼ l_crlf滻chr(10)һǱģ򽫲ܷʼжеʼ
    */
    write_data(l_conn, '', replace(replace(p_txt, l_splite, chr(10)), chr(10), l_crlf), '', '');
    end_boundary(l_conn);

    /*رд*/
    utl_smtp.close_data(l_conn);
    /*ر*/
    utl_smtp.quit(l_conn);

  end;
  --------------------------------------------------------------------------------------------------
begin
  l_sendoraddress := '<' || p_sendor || '>';
  p_splite_str(p_receiver);--ʼַ
  for k in 1 .. my_address_list.count loop
    p_email(l_sendoraddress, my_address_list(k));
  end loop;
  /*ʼַݶŷָʼ*/
end;